
/*This program reads from the input as arguments the size of panel,
 *the # of input files, the input files and the output file 
 *and then it draws on the panel shapes according to the specified info,
 * and prints in the output the given info*/	
import java.awt.*;
import java.io.*;
import java.util.*;
public class GraphicsProcessor {
	public static void main(String[] args) 
			throws FileNotFoundException {
		int w = Integer.parseInt(args[0]);
		int h = Integer.parseInt(args[1]);
		int N = Integer.parseInt(args[2]);
		DrawingPanel panel = new DrawingPanel(w, h);
		Graphics gr = panel.getGraphics();
		File out = new File(args[N + 3]);
		PrintStream output = new PrintStream(out);
		output.println(w + " " + h);
		for (int i = 1; i <= N; i++) {
			File in = new File(args[i + 2]);
			processGraphics(in, output, gr);
		}
	}
	//This method draws the shapes and prints their info in an output file
	public static void processGraphics(File in, PrintStream output, Graphics gr)
			throws FileNotFoundException {
		Scanner input = new Scanner(in);
		while (input.hasNextLine()) {
			String line = input.nextLine();
			Scanner lineScan = new Scanner(line);
			String shape = lineScan.next();
			int r = lineScan.nextInt();
			int g = lineScan.nextInt();
			int b = lineScan.nextInt();
			int x = lineScan.nextInt();
			int y = lineScan.nextInt();
			gr.setColor(new Color(r, g, b));
			
			if (shape.equals("Oval") || shape.equals("Rect")) {
				drawOvRe(lineScan, shape, gr, r, g, b, x, y);
			}
			else if (shape.equals("Poly")) {
				drawPol(lineScan, shape, gr, r, g, b, x, y);
			}
			else if (shape.equals("Line")) {
				drawLine(lineScan, shape, gr, r, g, b, x, y);
			}
			else if (shape.equals("Text")) {
				drawText(lineScan, shape, gr, r, g, b, x, y);
			}
			output.println(line);
		}
		input.close();
	}
	//This method draws an oval or a rectangle
	public static void drawOvRe(Scanner lineScan, String shape, Graphics gr, int r, int g, int b, int x, int y) {
		int wi = lineScan.nextInt();
		int he = lineScan.nextInt();
		String DF = lineScan.next();
		if (DF.equals("D")) {
			if (shape.equals("Rect"))
				gr.drawRect(x, y, wi, he);
			else if (shape.equals("Oval"))
				gr.drawOval(x, y, wi, he);
		} 
		else if (DF.equals("F")) {
			if (shape.equals("Rect"))
				gr.fillRect(x, y, wi, he);
			else if (shape.equals("Oval"))
				gr.fillOval(x, y, wi, he);
		}
	}
	//This method draws a polygon
	public static void drawPol(Scanner lineScan, String shape, Graphics gr, int r, int g, int b, int x, int y) {
		int xN, yN;
		Polygon poly = new Polygon();
		poly.addPoint(x, y);
		while(lineScan.hasNextInt()){
			xN = lineScan.nextInt();
			yN = lineScan.nextInt();
			poly.addPoint(xN, yN);
		}
		String DF = lineScan.next();
		if(DF.equals("F"))
			gr.fillPolygon(poly);
		else if(DF.equals("D"))
			gr.drawPolygon(poly);
	}
	//This method draws a line
	public static void drawLine(Scanner lineScan, String shape, Graphics gr, int r, int g, int b, int x, int y){
		int x2 = lineScan.nextInt();
		int y2 = lineScan.nextInt();
		gr.drawLine(x, y, x2, y2);
	}
	//This  method prints text
	public static void drawText(Scanner lineScan, String shape, Graphics gr, int r, int g, int b, int x, int y) {
		String text = lineScan.nextLine();
		gr.drawString(text, x, y);
	}
}