
/*This program takes N first(or last) lines of an input file
 *and prints them in an output file, if N > # of lines of input
 *otherwise it prints all lines*/	
import java.io.*;
import java.util.*;
public class LinuxDisplay {
	public static void main(String[] args) throws FileNotFoundException {
		File in = new File(args[0]);
		File out = new File(args[3]);
		int N = Integer.parseInt(args[2]);
		String top_tail = args[1];
		PrintStream output = new PrintStream(out);
		Scanner input = new Scanner(in);
		if(top_tail.equals("top")){
			if(countLine(in, out) >= N)
				topPrint(N, input, output);
			else
				printAll(N, input, output, in, out);
		}
		else if(top_tail.equals("tail")){
			if(countLine(in, out) >= N)
				tailPrint(N, input, output, in, out);
			else
				printAll(N, input, output, in, out);
		}
		else
			output.println("Invalid Argument");
	}
	//This method counts the number of lines of the input file
	public static int countLine(File in, File out) throws FileNotFoundException{
		Scanner input = new Scanner(in);
		int count = 0;
		while (input.hasNextLine()) {
			input.nextLine();
			count++;
		}
		input.close();
		return count;
	}
	//This method prints the top part of the input
	public static void topPrint(int N, Scanner input, PrintStream output){
		for(int i = 1; i <= N ; i++){
			String line = input.nextLine();
			output.println(line);
		}
	}
	//This method prints the lower part of the input
	public static void tailPrint(int N, Scanner input, PrintStream output, File in, File out) throws FileNotFoundException{
		for(int i = 1; i <= countLine(in, out) ; i++){
			if(i <= (countLine(in, out) - N))
				input.nextLine();
			else{
				String line = input.nextLine();
				output.println(line);
			}
		}
	}
	//This method prints the whole input
	public static void printAll(int N, Scanner input, PrintStream output, File in, File out) throws FileNotFoundException{
		for(int i = 1; i <= countLine(in, out) ; i++){
			String line = input.nextLine();
			output.println(line);
		}
	}
}