
//This program emulates the game Hangman
import java.io.*;
import java.util.*;
public class Hangman {
	public static void main(String[] args) throws FileNotFoundException {
		File in = new File("words.txt");
		Scanner toGuess = new Scanner(in);
		Scanner console = new Scanner(System.in);
		String misses = "";
		while(toGuess.hasNext()){	//repeats the progrm as long as the input has more words
			String tG = toGuess.next();
			System.out.print("Enter the maximum number of guesses: ");
			int n = console.nextInt();
			char[] word = new char[tG.length()];
			fillDash(word);
			checkGuess(misses, n, tG, word,console);
		}
		toGuess.close();
		console.close();
	}
	//This method prints the elements of an array separated by a space
	public static void printArray(char[] array){
		for(int i = 0; i < array.length; i++){
			System.out.print(array[i] + " ");
		}
		System.out.println();
	}
	//This method fills the elements of an array with underscores
	public static void fillDash(char[] array){
		for(int i = 0; i < array.length; i++){
			array[i] = '_';
		}
		System.out.println();
	}
	//This method checks the guess of a letter and counts the number of misses then prints the answer
	public static void checkGuess(String misses, int n, String tG, char[] word, Scanner console){
		while(n > 0 && Arrays.toString(word).contains("_")){
			System.out.print("Word: ");
			printArray(word);
			System.out.print("Misses: " + misses + "\n");
			System.out.print("Guess: ");
			char guess = console.next().charAt(0);
			System.out.println();
			boolean b = false;
			for(int i = 0; i < word.length; i++){
				if(Character.toLowerCase(tG.charAt(i)) == Character.toLowerCase(guess)){
					word[i] = tG.charAt(i);
					b = true;
				}
			}
			if(!b && !misses.contains("" + guess)){
				n--;
				misses += guess + " ";
			}
			nextAns(b, misses, guess, n, tG, word);
		}
	}
	//This method prints if the user wins or loses
	public static void nextAns(boolean b, String misses, char guess, int n, String tG, char[] word){
		if(n == 0)
			System.out.println("You Lost! The word was: " + tG + "\n");
		else if(!Arrays.toString(word).contains("_"))
			System.out.println("You Won! The word was: " + tG + "\n");
	}
}