
//This program emulates the search puzzle game
import java.io.*;
import java.util.*;
public class SearchPuzzle {
	public static void main(String[] args) throws FileNotFoundException {
		File in = new File(args[0]);
		Scanner input = new Scanner(in);
		int row=input.nextInt();
		int column=input.nextInt();
		input.nextLine();
		String Line = input.next();
		String word = args[1];
		System.out.println(wordScan(row, column, grid(row, column, Line), letters(word), word));
		input.close();
	}
	//This method fills a grid in a two dimensional array of letters
	public static char[][] grid(int row, int column, String Line){
		char[][]puzzle = new char[row][column];
		int count = 0;
		for(int i = 0; i < row; i++){
			for(int j = 0; j < column; j++){
				puzzle[i][j]= Line.charAt(count);
				count++;
			}
		}
		return puzzle;
	}
	//This method puts the letters of a word in an array
	public static char[] letters(String word){
		char[] letters = new char[word.length()];
		for(int i = 0; i < word.length(); i++){
			letters[i] = word.charAt(i);
		}
		return letters;
	}
	/*This method checks if a word may be found in a two dimensional array of letters
	 * going in 2 directions, left to right and up to down*/
	public static String wordScan(int row, int column, char[][] puzzle, char[] letters, String word){
		for (int i = 0; i < row; i++) {
		    for (int j = 0; j < column; j++) {
				boolean found = true;
				for(int k = 0; k < letters.length; k++) {
				    if ( (j+k >= column) || (letters[k] != puzzle[i][j+k]) ) {
					found = false;
					break;
				    }
				}
				if (found)
				    return word + " found: row " + (i+1) + ", column " + (j+1) + ", going right";
		    }
		}
		for (int i = 0; i < column; i++) {
		    for (int j = 0; j < row; j++) {
				boolean found = true;
				for(int k = 0; k < letters.length; k++) {
				    if ( (j+k >= row) || (letters[k] != puzzle[j+k][i]) ) {
					found = false;
					break;
				    }
				}
				if (found)
				    return word + " found: row " + (j+1) + ", column " + (i+1) + ", going down";
		    }
		}
		return word + " not found.";
	}
}
