
//This program implements the methods of different functions in the world of "Sets" in math
import java.util.*;
public class Set {
	//In the main I implemented print statements to test each method created
	public static void main(String[] args) {
		System.out.println(Arrays.toString(createSet("611")));
		System.out.println(cardinality(createSet("611")));
		System.out.println(inSet(createSet("611"), 2));
		addElement(createSet("611"), 4);
		System.out.println(equals(createSet("611"), createSet("6151")));
		System.out.println(Arrays.toString(union(createSet("611"), createSet("234"))));
		System.out.println(Arrays.toString(intersect(createSet("611"), createSet("2314"))));
		System.out.println(toString(createSet("1111132")));
		boolean[][] sets = {createSet("611"), createSet("23"), createSet("45")};
		System.out.println(Arrays.toString(multiUnion(sets)));
	}
	//This method creates a set of booleans and returns it
	public static boolean[] createSet(String s){
		boolean[] array = new boolean[10];
		for(int i = 0; i < 10; i++){
			if(s.contains("" + i))
				array[i] = true;	
		}
		return array;
	}
	//This method returns the cardinality # of a set of boolean array
	public static int cardinality(boolean[] set){
		int count = 0;
		for(int i = 0; i < 10; i++){
			if(set[i] == true) 
				count++;
		}
		return count;
	}
	//This method checks if a # d is present in a set of boolean array
	public static boolean inSet(boolean[] set, int d){
		if(set[d] == true)
			return true;
			return false;
	}
	/*This method adds an element d to an array
	 *The print statement in this method is for testing it
	 *as specified in the question */
	public static void addElement(boolean[] set, int d){
		if(!inSet(set, d)) 
			set[d] = true;
		System.out.println(Arrays.toString(set));
	}
	//This method checks if 2 boolean arrays have the same elements
	public static boolean equals(boolean[] set1, boolean[] set2){
		for(int i = 0; i < set1.length; i++){
			if(set1[i] != set2[i]) 
				return false;
		}
		return true;
	}
	//This method returns a set of booleans of union between 2 boolean arrays
	public static boolean[] union(boolean[] set1, boolean[] set2){
		boolean[] union = new boolean[set1.length];
		for(int i = 0; i < set1.length; i++){
			if(inSet(set1, i) || inSet(set2, i)) 
				union[i] = true;
		}
		return union;
	}
	//This method returns a set of booleans of the intersection between 2 boolean arrays
	public static boolean[] intersect(boolean[] set1, boolean[] set2){
		boolean[] intersect = new boolean[set1.length];
		for(int i = 0; i < set1.length; i++){
			if(inSet(set1, i) && inSet(set2, i)) 
				intersect[i] = true;
		}
		return intersect;
	}
	//This method returns the string representation of a set
	public static String toString(boolean[] set){
		if(set.length - 1 == -1)
			return "{}";
		String str_set = "{";
		for(int i = 0; i < set.length; i++){
			if(inSet(set, i))
				str_set += i;
			if(cardinality(set) == (str_set.length()-1)/2 || cardinality(set) == str_set.length()-1)
				return str_set += "}";
			if(str_set.contains("" + i))
				str_set += ", ";
		}
		return"";
	}
	//This method returns a set of booleans of union of multiple boolean arrays
	public static boolean[] multiUnion(boolean[][] sets){
		boolean[] mul_uni = new boolean[10];
		for(int i = 0; i < sets.length; i++){
			mul_uni = union(union(createSet(Arrays.toString(mul_uni)), sets[i]) , mul_uni);
		}
		return mul_uni;
	}
}