import java.io.*;
import java.util.*;

//This class implements different methods used in bank business
//It uses an array of accounts as an instance variable
public class Bank {
	Account[] accArray;
	//This method takes from a file different bank accout information
	public Bank(String filename) throws FileNotFoundException{
		Scanner file = new Scanner(new File(filename));
		int count = 0;
		while(file.hasNextLine()){
			count++;
			file.nextLine();
		}
		accArray = new Account[count];
		file = new Scanner(new File(filename));
		int i = 0;
		while(file.hasNextLine()){
			String line  = file.nextLine();
			Scanner lineScan = new Scanner(line);
			Account acc = new Account(lineScan.nextInt(), lineScan.next(), lineScan.nextDouble());
			accArray[i] = acc;
			i++;
		}
	}
	//getter of the accounts array
	public Account[] getAccArray(){
		return accArray;
	}
	//Closes an account in a bank
	public boolean close(int id){
		for(int i = 0; i < accArray.length; i++){
			if(accArray[i].getId() == id){
				swap(i);
				return true;
			}
		}
		return false;
	}
	//Swaps elemnts in an array
	public void swap(int i){
		Account[] copy = Arrays.copyOf(accArray, accArray.length - 1);
		for(int j = i; j < copy.length; j++){
			copy[j] = accArray[j+1];
		}
		accArray = copy;
	}
	//opens a new account in a bank
	public boolean open(int id, String name, double balance){
		int initialL = accArray.length;
		for(int i = 0; i < accArray.length; i++){
			if(accArray[i].getId() == id){
				return false;
			}
		}
		newElement();
		accArray[initialL] = new Account(id, name, balance);
		return true;
	}
	//Resizes an array
	public void newElement(){
		Account[] copy = Arrays.copyOf(accArray, accArray.length + 1);
		accArray = copy;
	}
	//transfer balance from an account to another
	public boolean transfer(int idFrom, int idTo, double balance){
		for(int i = 0; i < accArray.length; i++){
			if(accArray[i].getId() == idFrom){
				accArray[i].withdraw(balance);
				break;
			}
		}
		
		for(int i = 0; i < accArray.length; i++){
			if(accArray[i].getId() == idTo){
				accArray[i].deposit(balance);
				return true;
			}
		}
		return false;
	}
	//The string representation of the output
	public String toString(){
		String str = "";
		str += "(";
		for(int i = 0; i < accArray.length; i++){
			str += accArray[i];
		}
		str = str.substring(0,str.length()-2);
		str += ")";
		return str;
	}
}