import java.awt.*;
import java.util.*;

//This class implements different methods used in a polygon
//It uses an array of points as an instance variable
public class Polygon {
	private Point[] pArray;
	//Polygon empty constructor
	public Polygon(){
		pArray = new Point[1000];
	}
	//Adds points to a polygon
	public void addPoint(Point p){
		for(int i = 0; i < 1000; i++){
			if(pArray[i] == null){
				pArray[i] = p;
				System.out.println(Arrays.toString(pArray));
				break;
			}
		}
	}
	//draws a polygon
	public void draw(Graphics g){
		int j = 0;
			for(int i = 0; pArray[i] != null; i++){
				if(pArray[i+1] != null){
					g.drawLine(pArray[i].x, pArray[i].y, pArray[i+1].x, pArray[i+1].y);
				}
				j = i;
			}
			g.drawLine(pArray[j].x, pArray[j].y, pArray[0].x, pArray[0].y);
	}
	//creates a polygon consisting of the midpoints of the points in the called polygon
	public Polygon midPoints(){
		Polygon midPoly = new Polygon();
		int i = 0;
		Point pInitial = pArray[0];
		while(pArray[i+1] != null){
			midPoly.pArray[i] = pArray[i].midPoint(pArray[i+1]);
			i++;
		}
		midPoly.pArray[i] = pArray[i].midPoint(pInitial);
		return midPoly;
	}
	//computes the perimeter of a polygon
	public double perimeter(){
		int i = 0;
		Point pInitial = pArray[0];
		double sum = 0;
		while(pArray[i+1] != null){
			sum += pArray[i].distance(pArray[i+1]);
			i++;
		}
		sum += pArray[i].distance(pInitial);
		return sum;
	}
	//String representation
	public String toString(){
		String str = "";
		int i = 0;
		while(pArray[i] != null){
			str += "(" + pArray[i].x + "," + pArray[i].y + ")" + "-";
			i++;
		}
		return str.substring(0, str.length()-1);
	}
	//In the main are some statements to test our methods
	public static void main(String[] args) {
		DrawingPanel	panel	=	new DrawingPanel(100,	100);
		Polygon	polygon	=	new Polygon();
		Point	p1	=	new Point(10,	10);
		Point	p2	=	new Point(60,	10);
		Point	p3	=	new Point(60,	60);
		Point	p4	=	new Point(10,	60);
		polygon.addPoint(p1);
		polygon.addPoint(p2);
		polygon.addPoint(p3);
		polygon.addPoint(p4);
		System.out.println(polygon); //	prints	(10,10)-(60,10)-(60,60)-(10,60)		
		System.out.println(polygon.perimeter()); //	prints	200.0
		Polygon	midPointsPolygon	=	polygon.midPoints();
		polygon.draw(panel.getGraphics());
		midPointsPolygon.draw(panel.getGraphics());
	}

}