import java.io.*;
import java.util.*;

//This program applies the methods in the bank class
public class TestBank {
	public static void main(String[] args) throws FileNotFoundException {
		Scanner console = new Scanner(System.in);
		System.out.println("Main Menu (1: Open - 2: Close - 3: Balance - 4: Withdraw - 5: Deposit - 6: Transfer - 7: Load - 8: Exit");
		System.out.print("Enter a choice: ");
		int choice = console.nextInt();
		Bank b = new Bank("test.txt");
		if(choice == 1){//So we use the open method in the bank class
			System.out.print("Enter the account info (id, name, initial balance): ");
			int id = console.nextInt();
			String name = console.next();
			double inBalance = console.nextDouble();
			if(b.open(id, name, inBalance) == true)
				System.out.println("The account has been created successfully");
			else
				System.out.println("ID already found");
		}
		else if(choice == 2){//So we use the close method in the bank class
			System.out.print("Enter the account id: ");
			int id = console.nextInt();
			boolean idFound = false;
			for(int i = 0; i < b.getAccArray().length; i++){
				if(b.getAccArray()[i].getId() == id){
					idFound = true;
					break;
				}
			}
			if(idFound){
				b.close(id);
				System.out.println("The balance is successfully closed");
			}
			else
				System.out.println("ID not found");
		}
		else if(choice == 3){//So we use the getBalance method in account class called through bank class
			System.out.print("Enter the account id: ");
			int id = console.nextInt();
			boolean idFound = false;
			int idIndex = 0;
			for(int i = 0; i < b.getAccArray().length; i++){
				if(b.getAccArray()[i].getId() == id){
					idFound = true;
					idIndex = i;
					break;
				}
			}
			if(idFound)
				System.out.println("The balance is " + b.getAccArray()[idIndex].getBalance());
			else
				System.out.println("ID not found");
			
		}
		else if(choice == 4){//So we use the withdraw method in the Account class called through the bank class
			System.out.print("Enter the account id and amount of withdrawal ");
			int id = console.nextInt();
			double amount = console.nextDouble();
			boolean idFound = false;
			int idIndex = 0;
			for(int i = 0; i < b.getAccArray().length; i++){
				if(b.getAccArray()[i].getId() == id){
					idFound = true;
					idIndex = i;
					break;
				}
			}
			if(idFound){
				b.getAccArray()[idIndex].withdraw(amount);
				System.out.println("The amount is succesfully withdrawn");
			}
			else
				System.out.println("ID not found");
		}
		else if(choice == 5){//So we use the deposit method in the account class called through the bank class
			System.out.print("Enter the account id and amount of deposit: ");
			int id = console.nextInt();
			double amount = console.nextDouble();
			boolean idFound = false;
			int idIndex = 0;
			for(int i = 0; i < b.getAccArray().length; i++){
				if(b.getAccArray()[i].getId() == id){
					idFound = true;
					idIndex = i;
					break;
				}
			}
			if(idFound){
				b.getAccArray()[idIndex].deposit(amount);
				System.out.println("The amount is successfully depositted");
			}
			else
				System.out.println("ID not found");
		}
		else if(choice == 6){//So we use the method transfer in the bank class
			System.out.print("Enter idFrom, idTo, Balance: ");
			int idFrom = console.nextInt();
			int idTo = console.nextInt();
			double balance = console.nextDouble();
			b.transfer(idFrom, idTo, balance);
			System.out.println("The amount is successfully transfered");
		}
		else if(choice == 7){//So we use the method open to create a new account in the bank
			System.out.print("Enter the file name");
			File file = new File(console.next());
			Scanner fileScan = new Scanner(file);
			int i = 0;
			while(fileScan.hasNextLine()){
				String line  = fileScan.nextLine();
				Scanner lineScan = new Scanner(line);
				int id = lineScan.nextInt();
				String name = lineScan.next();
				double balance = lineScan.nextDouble();
				b.open(id, name, balance);
				i++;
			}
			System.out.println("The accounts are successfully loaded");
		}
		else if(choice == 8){//So we print the bank info
			System.out.println(b);
		}
		console.close();
	}

}