import java.util.Scanner; //to use the scanner

/*This program takes input from the user(date of birth) and prints his/her
 * zodiac sign and daily horoscope corresponding to the date of birth*/
public class Astrology {
	public static void main(String[] args) {
		Scanner console = new Scanner(System.in);
		System.out.print("Enter your date of birth: ");
		String date = console.next();
		String[] str = date.split("/");
		System.out.println(zodiac(str[0], str[1], str[2]));
		System.out.println(horoscope(str[0], str[1], str[2]));
	}
	/*returns the zodiac sign of the given date of birth if valid and returns
	 * invalid(day or month or year) if the day or month or year is invalid*/
	public static String zodiac(String da, String mon, String yr){
		int day = Integer.parseInt(da);
		int month = Integer.parseInt(mon);
		int year = Integer.parseInt(yr);
		String invalid = "";
		if((day >= 32) || ((day>=29 && day<=31) && month==2) || ((day==31) && (month==4 || month==6 || month==9 || month==11))) 
			invalid += "Invalid day!\n";
		if(month >= 13)
			invalid += "Invalid month!\n";
		if(year >= 2015)
			invalid += "Invalid year!";
		if(((month == 1 && (day >= 20 && day <= 31)) || (month==2 && (day >= 1 && day <= 18))) && year<=2014)
			return "Your zodiac sign is Aquarius";
		else if(((month == 2 && (day >= 19 && day <= 28)) || (month==3 && (day >= 1 && day <= 20))) && year<=2014)
			return "Your zodiac sign is Pisces";
		else if(((month == 3 && (day >= 21 && day <= 31)) || (month==4 && (day >= 1 && day <= 19))) && year<=2014)
			return "Your zodiac sign is Aries";
		else if(((month == 4 && (day >= 20 && day <= 30)) || (month==5 && (day >= 1 && day <= 20))) && year<=2014)
			return "Your zodiac sign is Taurus";
		else if(((month == 5 && (day >= 21 && day <= 31)) || (month==6 && (day >= 1 && day <= 20))) && year<=2014)
			return "Your zodiac sign is Gemini";
		else if(((month == 6 && (day >= 21 && day <= 30)) || (month==7 && (day >= 1 && day <= 22))) && year<=2014)
			return "Your zodiac sign is Cancer";
		else if(((month == 7 && (day >= 23 && day <= 31)) || (month==8 && (day >= 1 && day <= 22))) && year<=2014)
			return "Your zodiac sign is Leo";
		else if(((month == 8 && (day >= 23 && day <= 31)) || (month==9 && (day >= 1 && day <= 22))) && year<=2014)
			return "Your zodiac sign is Virgo";
		else if(((month == 9 && (day >= 23 && day <= 30)) || (month==10 && (day >= 1 && day <= 22))) && year<=2014)
			return "Your zodiac sign is Libra";
		else if(((month == 10 && (day >= 23 && day <= 31)) || (month==11 && (day >= 1 && day <= 21))) && year<=2014)
			return "Your zodiac sign is Scorpio";
		else if(((month == 11 && (day >= 22 && day <= 30)) || (month==12 && (day >= 1 && day <= 21))) && year<=2014)
			return "Your zodiac sign is Sagittarius";
		else if(((month == 12 && (day >= 22 && day <= 31)) || (month==1 && (day >= 1 && day <= 19))) && year<=2014)
			return "Your zodiac sign is Capricorn";
		else
			return invalid;
	}
	/*returns the daily horoscope of the given date of birth if valid and nothing if date is invalid
	 * depending on the zodiac sign determined in the method zodiac()*/
	public static String horoscope(String da, String mon, String yr){
		if(zodiac(da, mon, yr).equals("Your zodiac sign is Aquarius"))
			return "Your daily horoscope is:\n" +
					"\"The day is generally quite warm and friendly, dear Aquarius. Your ability to pick up on the subtlest of cues in your environment\n" +
					" enhances your knowledge. You might feel inspired to do something selfless in order to help others, and feel especially strong when\n" +
					" working towards an ideal or cause. Your more altruistic or idealistic side is strongly stimulated now. Past good deeds may be rewarded.\n" +
					" It's a powerful day for getting in touch with your innermost desires.\"";
		else if(zodiac(da, mon, yr).equals("Your zodiac sign is Pisces"))
			return "Your daily horoscope is:\n" +
					"\"You are at your most attractive right now when you let things unfold naturally and display patience, dear Pisces. Someone may\n" +
					" communicate romantic interest in a subtle manner. You are feeling hopeful and optimistic. A friend can be supportive. Align yourself\n" +
					" with a worthy cause. It's a wonderful time for unified action, joining with others, pitching in, getting involved, and helping people.\n" +
					" Thinking is clearest when it concerns work and health matters.\"";
		else if(zodiac(da, mon, yr).equals("Your zodiac sign is Aries"))
			return "Your daily horoscope is:\n" +
					"\"This is a pleasing day for love and business matters, dear Aries. Someone can be amorous and showing definite interest\n" +
					" and sincere concern for your needs. Beautiful energy is with you for feeling in sync with people around you and with your\n" +
					" environment. By extension, you are displaying a quiet confidence that endears others to you. You feel pleasantly effective,\n" +
					" competent, and ambitious. Stay active and involved now for best results. Strategy works with both your practical and personal affairs.\"";
		else if(zodiac(da, mon, yr).equals("Your zodiac sign is Taurus"))
			return "Your daily horoscope is:\n" +
					"\"You are strong when it comes to negotiations, mutual agreements, and business decisions today, dear Taurus. You tuned into the more\n" +
					" subtle or otherworldly elements of life right now, and thus your understanding of others, yourself, and your purpose can increase.\n" +
					" Helping someone out, offering sincere and mindful advice, being a source of comfort, and inspiring others with your insight can\n" +
					" figure strongly now, and can also lift your spirits. It's especially satisfying to put others' needs before yours.\"";
		else if(zodiac(da, mon, yr).equals("Your zodiac sign is Gemini"))
			return "Your daily horoscope is:\n" +
					"\"You can be especially cooperative and open with someone, and this is returned, dear Gemini. Turn on the charm! Communication, mental\n" +
					" pursuits and interests, romance, and work are all in good shape right now. You can be both productive and sociable right now and get\n" +
					" away with both. It's a more balanced day than usual. There is more optimism in your exchanges and interactions. Accept support and help\n" +
					" graciously, as it's unlikely to be insincere today.\"";
		else if(zodiac(da, mon, yr).equals("Your zodiac sign is Cancer"))
			return "Your daily horoscope is:\n" +
					"\"This is a potentially strong day for personal appeal and magnetism, dear Cancer, particularly when you are in a serving or helping mode.\n" +
					" Love is easily attracted and expressed today. You are sociable and receptive today, and you might learn something about a partner or a\n" +
					" friend that raises your respect levels further. Share personal philosophies and perspectives and enjoy the connection you feel to you\n" +
					" and to the world as you do. It's not a time for pushing your personal agenda - it's a time for learning about the needs and concerns of others.\n" +
					" Something may touch you or inspire you through your interactions with others.\"";
		else if(zodiac(da, mon, yr).equals("Your zodiac sign is Leo"))
			return "Your daily horoscope is:\n" +
					"\"There is good energy with you today for special invites, coming to agreements, and inner wellness, dear Leo. Special insight into a work matter\n" +
					" or method can come to you like a mini eureka. The trick is to let your mind to back away from a puzzling matter just enough that you allow\n" +
					" your intuition to take the driver's seat. There can be a stronger appreciation of the intangibles in life right now, and letting go of something\n" +
					" in order to embrace the new comes a little easier as a result.\"";
		else if(zodiac(da, mon, yr).equals("Your zodiac sign is Virgo"))
			return "Your daily horoscope is:\n" +
					"\"Relationships with family and people very close to you can strengthen today, dear Virgo. There can be an intuitive and possibly psychic\n" +
					" connection between you and a beloved. You can be especially charming - quite naturally - and although there is a mysterious air surrounding your\n" +
					" interactions that can be a tad confusing right now, it can also be quite alluring. Emotionally, however, you are not entirely ready to stray far\n" +
					" from the familiar. The arts, particularly dancing and physical creative arts, are favored for you today.\"";
		else if(zodiac(da, mon, yr).equals("Your zodiac sign is Libra"))
			return "Your daily horoscope is:\n" +
					"\"Social relations, comfort, and finances are starred for you today, dear Libra. You are magnetizing good things to you quite naturally now.\n" +
					" Interactions today tend to be easy and helpful. Socially, you tend to be at the right place at the right time. You are at your happiest now when\n" +
					" you are letting things flow naturally. You may be focusing on activities that improve the balance and warmth of your living and working\n" +
					" environments today. Complicated problems seem to be easier to understand when you allow your intuition to work for you.\"";
		else if(zodiac(da, mon, yr).equals("Your zodiac sign is Scorpio"))
			return "Your daily horoscope is:\n" +
					"\"This day favors mental tasks, communications of all kinds (speaking, writing), travel, and transportation for you, dear Scorpio. Finances can\n" +
					" improve, or you may get good news about practical matters and personal possessions. Emotionality is a possibility, but your ability to step back\n" +
					" from your emotions and to apply logic today tends to dominate. You're especially appealing right now, so be sure to express yourself.\"";
		else if(zodiac(da, mon, yr).equals("Your zodiac sign is Sagittarius"))
			return "Your daily horoscope is:\n" +
					"\"It's a good time to tap into your intuition, dear Sagittarius, as well as for connecting or coming to an agreement with an important player\n" +
					" in your life. Thinking about matters of the past can actually be quite productive now. You might, for example, experience deja vu or serendipity\n" +
					" as you go about your regular affairs. You are communicating your needs in effective ways, and life seems a little easier as a result. Attraction is\n" +
					" a strong note today. It's more about attracting than pursuing at the moment.\"";
		else if(zodiac(da, mon, yr).equals("Your zodiac sign is Capricorn"))
			return "Your daily horoscope is:\n" +
					"\"Strong energy is with you today for smart decision making along practical or business lines and good strategy in your personal life as well,\n" +
					" dear Capricorn. Friends are supportive, and you of them. You are very much in your element, and the inner idealist is drawn to healing and helpful\n" +
					" activities. You've been coming on quite strongly these days, with more energy to move personal plans forward and more directness in your requests.\n" +
					" Today, however, you have an added dose of personal magnetism and perhaps some serendipity going for you. Use this time for expressing yourself creatively and persuasively.\"";
		else
			return "";
	}
}