
/*This program draws a Backgammon of different sizes and dimensions
 * depending on the base width, the height of the panel, and the # of triangles taken from input as arguments*/
import java.awt.*;//to use the graphics
public class Backgammon {
	public static void main(String[] args) {
		int N = Integer.parseInt(args[0]), width = Integer.parseInt(args[1]);
		int pWidth = width + (2 * N), height = Integer.parseInt(args[2]);
		DrawingPanel panel = new DrawingPanel(pWidth, height);
		Graphics g = panel.getGraphics();
		Color brown = new Color(191, 118, 73);
		panel.setBackground(brown);
		Font font = new Font("Lucida Handwriting", Font.BOLD, width / 20);
		g.setFont(font);
		g.setColor(Color.WHITE);
		g.drawString("I Love Backgammon!", pWidth / 5, height / 2);
		for (int i = 0; i < N; i++) {
			upperTri(N, width, i, height, g);
			lowerTri(N, width, i, height, g);
		}
	}
	//This method draws the upper triangles of the backgammon
	public static void upperTri(int N, int width, int i, int height, Graphics g){
		if (i % 2 == 0) g.setColor(Color.BLACK);
		else g.setColor(Color.WHITE);
		Polygon tri = new Polygon();
		tri.addPoint(i * width / N + 2 * i + 1, 0);
		tri.addPoint((i + 1) * width / N + 2 * i + 1, 0);
		tri.addPoint((2 * i + 1) * (1 + width / (2 * N)), 3 * height / 8);
		g.fillPolygon(tri);
	}
	//This method draws the lower triangles of the backgammon
	public static void lowerTri(int N, int width, int i, int height, Graphics g){
		if (i % 2 == 0) g.setColor(Color.WHITE);
		else g.setColor(Color.BLACK);
		Polygon tri = new Polygon();
		tri.addPoint(i * width / N + 2 * i + 1, height);
		tri.addPoint((i + 1) * width / N + 2 * i + 1, height);
		tri.addPoint((2 * i + 1) * (1 + width / (2 * N)), 5 * height / 8);
		g.fillPolygon(tri);
	}
}