
/*This program takes a password from the user input and checks
 * if this password violates the specified rules(1,2,3,4) or not*/
import java.util.*;//to use the scanner
public class PasswordChecker {
	public static void main(String[] args) {
		Scanner console = new Scanner(System.in);
		for(; true;){
			System.out.print("Please enter your password: ");
			String str = console.next();
			if(passCheck(str).equals("valid password")){
				System.out.println(passCheck(str));
				break;
			}
			else
			System.out.println("not a valid password (rule(s): " + passCheck(str) + " violated)");
		}
	}
	//This method returns true if the password violates rule 1
	public static boolean rule1(String str){
		if(str.length()<=6 || str.length()>=15) return true;
		else return false; //true means rule 1 violated
	}
	//This method returns true if the password violates rule 2
	public static boolean rule2(String str){
		boolean viol = true;//true means rule 2 violated
		for(int i = 1; i <= str.length(); i++){
			if(Character.isLetter(str.charAt(i-1))) viol = viol && true;
			else viol = false; 
		}
		return viol;
	}
	//This method returns true if the password violates rule 3
	public static boolean rule3(String str){
		boolean viol = true;//true means rule 3 violated
		for(int i = 1; i <= str.length(); i++){
			if(Character.isDigit(str.charAt(i-1))) viol = viol && true;
			else viol = false; 
		}
		return viol;
	}
	//This method returns true if the password violates rule 4
	public static boolean rule4(String str){
		boolean viol = true;//true means rule 4 violated
		if(str.length()>2){
			for(int i = 0; i <= str.length()-3; i++){
				if(Character.isLetter(str.charAt(i)) && str.endsWith("99")) viol = viol && true;
				else viol = false; 
			}
		}
		else if(str.equals("99")||str.equals("9")) viol = false;
		return viol;
	}
	/*This method returns the number of the rule violated
	 * in the password if violated and returns valid if it's valid*/
	public static String passCheck(String str){
		if(rule1(str)){
			String answer = "1";
			if(rule2(str))
				answer += ",2";
			if(rule3(str))
				answer += ",3";
			if(rule4(str))
				answer += ",4";
			return answer;
		}
		else {
			String answer = "";
			if(rule2(str))
				answer = "2";
			else if(rule3(str))
				answer = "3";
			else if(rule4(str))
				answer = "4";
			else 
				answer = "valid password";
			return answer;
		}
	}
}
